﻿Public Class Row130923B

#Region "プロパティ"

    Private _activeCell As Control = Nothing

#End Region

#Region "プロセス"

    ''' <summary>
    ''' アクティブコントロール取得
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function FNC_ACEL_GET() As Control
        Return _activeCell
    End Function

    ''' <summary>
    ''' アクティブコントロール設定
    ''' </summary>
    ''' <param name="cellName"></param>
    ''' <remarks></remarks>
    Public Sub FNC_ACEL_SET(ByVal cellName As String)
        Dim D_OBJ As Control
        Dim D_OBJ2 As Control
        '
        For Each D_OBJ In Me.Controls
            If TypeName(D_OBJ) = "GroupBox" OrElse TypeName(D_OBJ) = "Panel" Then
                For Each D_OBJ2 In D_OBJ.Controls
                    If D_OBJ2.Name = cellName Then
                        _activeCell = D_OBJ2 : Exit Sub
                    End If
                Next
            ElseIf D_OBJ.Name = cellName Then
                _activeCell = D_OBJ : Exit Sub
            End If
        Next
    End Sub

    Public Sub FNC_CMB_LST_SET(ByVal cellName As String, ByVal table As DataTable, ByVal displayMember As String, ByVal valueMember As String)
        Dim D_OBJ As Control = Nothing
        '
        For Each D_OBJ In Me.Controls
            If D_OBJ.Name = cellName Then
                Exit For
            End If
        Next
        '
        If TypeName(D_OBJ) <> "MrcCombo" Then Exit Sub
        '
        CType(D_OBJ, ComboBox).DataSource = table
        CType(D_OBJ, ComboBox).DisplayMember = displayMember
        CType(D_OBJ, ComboBox).ValueMember = valueMember
    End Sub

    ''' <summary>
    ''' マルチローに他コントロールからフォーカスが移ってきたときの処理
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub FNC_FST_ENT_MROW()
        If IsNothing(_activeCell) Then Exit Sub
        _activeCell.Focus()
    End Sub

    ''' <summary>
    ''' セル値取得
    ''' </summary>
    ''' <param name="cellName"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function FNC_ITM_GET(ByVal cellName As String) As String
        Return UTL_Com.FindControl(Me, cellName).Text
    End Function

    ''' <summary>
    ''' セル値取得（コンボボックス）
    ''' </summary>
    ''' <param name="cellName"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function FNC_ITM_CMB_GET(ByVal cellName As String) As String
        Dim D_RTN As String = Nothing
        Dim D_OBJ As Object = Nothing
        '
        D_OBJ = UTL_Com.FindControl(Me, cellName)
        If TypeName(D_OBJ) = "MrcCombo" Then
            D_RTN = CType(D_OBJ, ComboBox).SelectedValue
        End If
        '
        Return D_RTN
    End Function

    ''' <summary>
    ''' セル値取得（チェックボックス）
    ''' </summary>
    ''' <param name="cellName"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function FNC_ITM_CHK_GET(ByVal cellName As String) As Boolean
        Dim D_RTN As Boolean = Nothing
        Dim D_OBJ As Object = Nothing
        '
        D_OBJ = UTL_Com.FindControl(Me, cellName)
        If TypeName(D_OBJ) = "MrcCheckBox" Then
            D_RTN = CType(D_OBJ, CheckBox).Checked
        End If
        '
        Return D_RTN
    End Function

    ''' <summary>
    ''' セル値取得（ラジオボタン）
    ''' </summary>
    ''' <param name="cellName"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function FNC_ITM_RDO_GET(ByVal cellName As String) As Boolean
        Dim D_RTN As Boolean = Nothing
        Dim D_OBJ As Object = Nothing
        '
        D_OBJ = UTL_Com.FindControl(Me, cellName)
        If TypeName(D_OBJ) = "MrcRadioButton" Then
            D_RTN = CType(D_OBJ, RadioButton).Checked
        End If
        '
        Return D_RTN
    End Function

    ''' <summary>
    ''' セル値設定
    ''' </summary>
    ''' <param name="cellName"></param>
    ''' <param name="value"></param>
    ''' <remarks></remarks>
    Public Sub FNC_ITM_SET(ByVal cellName As String, ByVal value As String)
        UTL_Com.FindControl(Me, cellName).Text = value
    End Sub

    ''' <summary>
    ''' セル値設定（コンボボックス）
    ''' </summary>
    ''' <param name="cellName"></param>
    ''' <param name="value"></param>
    ''' <remarks></remarks>
    Public Sub FNC_ITM_CMB_SET(ByVal cellName As String, ByVal value As String)
        Dim D_OBJ As Object = Nothing
        '
        D_OBJ = UTL_Com.FindControl(Me, cellName)
        If TypeName(D_OBJ) = "MrcCombo" Then
            CType(D_OBJ, ComboBox).SelectedValue = value
        End If
    End Sub

    ''' <summary>
    ''' セル値設定（チェックボックス）
    ''' </summary>
    ''' <param name="cellName"></param>
    ''' <param name="value"></param>
    ''' <remarks></remarks>
    Public Sub FNC_ITM_CHK_SET(ByVal cellName As String, ByVal value As Boolean)
        Dim D_OBJ As Object = Nothing
        '
        D_OBJ = UTL_Com.FindControl(Me, cellName)
        If TypeName(D_OBJ) = "MrcCheckBox" Then
            CType(D_OBJ, CheckBox).Checked = value
        End If
    End Sub

    ''' <summary>
    ''' セル値設定（ラジオボタン）
    ''' </summary>
    ''' <param name="cellName"></param>
    ''' <param name="value"></param>
    ''' <remarks></remarks>
    Public Sub FNC_ITM_RDO_SET(ByVal cellName As String, ByVal value As Boolean)
        Dim D_OBJ As Object = Nothing
        '
        D_OBJ = UTL_Com.FindControl(Me, cellName)
        If TypeName(D_OBJ) = "MrcRadioButton" Then
            CType(D_OBJ, RadioButton).Checked = value
        End If
    End Sub

#End Region

#Region "ActiveControlChangedイベント & CellClickイベント"
    '参考(ActiveControlChangedイベント)：http://blogs.wankuma.com/jeanne/archive/2007/04/02/69804.aspx
    '参考(CellClickイベント)：http://okwave.jp/qa/q1052988.html

    Public Event CellClick(ByVal sender As Control, ByVal e As System.EventArgs)
    Public Event CellTextChanged(ByVal sender As Control, ByVal e As System.EventArgs)

    Private Sub ChildControls_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        '
        If Not TypeOf sender Is System.Windows.Forms.Control Then
            Return
        End If
        '
        RaiseEvent CellTextChanged(sender, e)
    End Sub

    Private Sub ChildControls_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        If Not DirectCast(sender, System.Windows.Forms.Control).Focused Then
            DirectCast(sender, System.Windows.Forms.Control).Focus()
        End If

        '
        If Not TypeOf sender Is System.Windows.Forms.Control Then
            Return
        End If
        '
        RaiseEvent CellClick(sender, e)
    End Sub

    Private Sub ChildControls_Enter(ByVal sender As Object, ByVal e As System.EventArgs)
        If sender Is Nothing Then
            Return
        End If

        If Not TypeOf sender Is System.Windows.Forms.Control Then
            Return
        End If

        Dim cControl As System.Windows.Forms.Control = DirectCast(sender, System.Windows.Forms.Control)
        '
        _activeCell = cControl
    End Sub

    Private Sub ChildControls_ControlAdded(ByVal sender As Object, ByVal e As System.Windows.Forms.ControlEventArgs) Handles Me.ControlAdded
        If e Is Nothing Then
            Return
        End If

        If e.Control Is Nothing Then
            Return
        End If
        '
        FNC_HDL_ADD(e.Control)
        '
        If TypeName(e.Control) = "GroupBox" OrElse TypeName(e.Control) = "Panel" Then
            Dim D_GBOX_CTL As Control = Nothing
            For Each D_GBOX_CTL In e.Control.Controls
                FNC_HDL_ADD(D_GBOX_CTL)
            Next
        End If
    End Sub

    Private Sub FNC_HDL_ADD(ByRef CTL As Control)
        AddHandler CTL.Click, AddressOf ChildControls_Click
        AddHandler CTL.ControlAdded, AddressOf ChildControls_ControlAdded
        AddHandler CTL.ControlRemoved, AddressOf ChildControls_ControlRemoved
        AddHandler CTL.Enter, AddressOf ChildControls_Enter
        AddHandler CTL.TextChanged, AddressOf ChildControls_TextChanged
    End Sub

    Private Sub ChildControls_ControlRemoved(ByVal sender As Object, ByVal e As System.Windows.Forms.ControlEventArgs) Handles Me.ControlRemoved
        If e Is Nothing Then
            Return
        End If

        If e.Control Is Nothing Then
            Return
        End If

        FNC_HDL_RMV(e.Control)
        '
        If TypeName(e.Control) = "GroupBox" OrElse TypeName(e.Control) = "Panel" Then
            Dim D_GBOX_CTL As Control = Nothing
            For Each D_GBOX_CTL In e.Control.Controls
                FNC_HDL_RMV(D_GBOX_CTL)
            Next
        End If
    End Sub

    Private Sub FNC_HDL_RMV(ByRef CTL As Control)
        RemoveHandler CTL.Click, AddressOf ChildControls_Click
        RemoveHandler CTL.ControlAdded, AddressOf ChildControls_ControlAdded
        RemoveHandler CTL.ControlRemoved, AddressOf ChildControls_ControlRemoved
        RemoveHandler CTL.Enter, AddressOf ChildControls_Enter
        RemoveHandler CTL.TextChanged, AddressOf ChildControls_TextChanged
    End Sub

#End Region

End Class
